<?php
  include_once("gxml.php");
  include_once("background.php");
  include_once("htmlfuncs.php");
  include_once("pagemenu.php");
  include_once("checkout.php");
  include_once("logger.php");
  include_once("sort.php");
  include_once(SmartyClass());   
  
  function ItemLink($Item)
  {
    if (StaticLinks())
    {
      $Result  = DetailFile()."_ASIN_".rawurlencode($Item->ASIN[0]->Data).".htm";
    }
    else
    {
      $Result  = DetailFile()."?ASIN=".rawurlencode($Item->ASIN[0]->Data);
    }
    
    return $Result;
  }

  function GetItemImageRef($Item, $Caption)
  {
    $str = "\$Temp = \$Item->$Caption"."[0]"."->Data;";
    eval("\$Temp = \$Item->$Caption"."[0]"."->Data;");
    
    //If the image is blank, return a blank image instead.
    //We use getimagesize with @ in front of it so it won't return a warning if it fails.
    list($width, $height, $type, $attr) = @getimagesize($Temp);
    if ($width <= 1)
    {
      $Temp = "tbimages/books-no-image.gif";
    }

    return $Temp;
  }

  function GetItemImage($Item, $Caption)
  {
    return GetItemImageRef($Item, $Caption);
  }
  
  function GetArtists($Artists)
  {
    $Result = "";
    $i = 0;
    while (isset($Artists->ARTIST[$i]->Data))
    {
      if ($i != 0)
      {
        $Result .= ", ";
      }
      $Result .= $Artists->ARTIST[$i]->Data;
      $i++;
    }    
    return $Result;
  }
  
  function GetAuthors($Authors)
  {
    $Result = "";
    $i = 0;
    while (isset($Authors->AUTHOR[$i]->Data))
    {
      if ($i != 0)
      {
        $Result .= ", ";
      }
      $Result .= $Authors->AUTHOR[$i]->Data;
      $i++;
    }
    return $Result;
  }  
   
  function GetItemListPrice($Item)
  {
    $Availability = strtoupper($Item->AVAILABILITY[0]->Data);
    if (substr_count($Availability, "NOT AVAILABLE") ||
        substr_count($Availability, "NOT STOCK")     ||
        substr_count($Availability, "DISCONTINUE"))
    {
      $Result = "Not Available";
    }
    else
    {
      $Result  = $Item->LISTPRICE[0]->Data;
    }    
    return $Result;
  }
  function GetItemOurPrice($Item)
  {
    $Availability = strtoupper($Item->AVAILABILITY[0]->Data);
    if (substr_count($Availability, "NOT AVAILABLE") ||
        substr_count($Availability, "NOT STOCK")     ||
        substr_count($Availability, "DISCONTINUE"))
    {
      $Result = "Not Available";
    }
    else
    {
      $Result = $Item->OURPRICE[0]->Data;
    }    
    return $Result;
  }  
 
  function GetImageSizeCaption($ImageSize)
  {
    $Result = "IMAGEURLSMALL";
    if ($ImageSize==2)
    {
      $Result = "IMAGEURLMEDIUM";
    }
    else
    {
      if ($ImageSize==3)
      {
        $Result = "IMAGEURLLARGE";
      }
    }
    return $Result;
  }
  
  //Returns the item under the XML DETAILS[$Index].  Inspect $Obj for more details.
  function GetItem($Obj, $Index)
  {
    if (isset($Obj->PRODUCTINFO[0]->DETAILS[$Index]))
    {
      return $Obj->PRODUCTINFO[0]->DETAILS[$Index];
    }
    else
    {
      return 0;
    }
  }
  
  //Returns an HTML table of the items.
  function GetItemList($Obj, $ItemsPerRow, $ImageSize, $Page)
  {
    $NumItems         = 10;
    $ImageSizeCaption = GetImageSizeCaption($ImageSize);

    for($i = 0; $i < $NumItems; $i++)
    {
      $Item          = GetItem($Obj, $i);
      $ImageSrc[$i]  = GetItemImage($Item, $ImageSizeCaption);
      $ItemLink[$i]  = ItemLink($Item);
      $Title[$i]     = $Item->PRODUCTNAME[0]->Data;
      $Authors[$i]   = GetArtists($Item->ARTISTS[0]).GetAuthors($Item->AUTHORS[0]);
      $ListPrice[$i] = GetItemListPrice($Item);
      $OurPrice[$i]  = GetItemOurPrice($Item);
    }

    //Create template object.
    $ResultsTemplate = new Smarty;
    $ResultsTemplate->compile_dir = FullSmartyCompileDir();    
    
    $ResultsTemplate->Assign('NumItems',  $NumItems);
    $ResultsTemplate->Assign('ImageSrc',  $ImageSrc);
    $ResultsTemplate->Assign('ItemLink',  $ItemLink);
    $ResultsTemplate->Assign('Title',     $Title);
    $ResultsTemplate->Assign('Authors',   $Authors);
    $ResultsTemplate->Assign('ListPrice', $ListPrice);
    $ResultsTemplate->Assign('OurPrice',  $OurPrice);
    $ResultsTemplate->Assign('Page',      $Page);
    
    return $ResultsTemplate->fetch('templates'.DirDelimiter().'body.tpl.htm');         
  }
  
  //Creates a list of clickable items to purchase.  Clicking on each item
  // brings up a detail screen.
  //$ImageSize 1: SMALL, 2: MEDIUM, 3: LARGE
  function body($Associate, $Category, $Keywords, $Page, $Sort, $CartID, $HMAC, $SearchType, $Node)
  {
    //Log the keywords that were searched on.
    LogT("S", $Keywords);

    if ($SearchType == "Node")
    {
      $Filename    = "http://xml.amazon.com/onca/xml3?t=$Associate&dev-t=".DevKey()."&BrowseNodeSearch=$Node&type=heavy&page=$Page&f=xml&mode=".$Category;
    }
    else
    {
      $Filename    = "http://xml.amazon.com/onca/xml2?t=" . $Associate . "&dev-t=".DevKey()."&mode=".$Category."&type=lite&page=" . $Page . "&f=xml&KeywordSearch=" . rawurlencode($Keywords) . "&sort=$Sort";
    }

    $Obj         = GXMLTree($Filename);
    $TotalPages  = $Obj->PRODUCTINFO[0]->TOTALPAGES[0]->Data;
    
    if (StaticLinks())
    {
      if ($SearchType == "Node")
      {
        $PageLink    = ListFile()."_Category_".$Category."_SearchType_".$SearchType."_Node_".$Node;
      }
      else
      {
        $PageLink    = ListFile()."_Category_".$Category."_Keywords_".rawurlencode($Keywords);
      }
    }
    else
    {
      $PageLink    = ListFile()."?Category=$Category&Keywords=".rawurlencode($Keywords)."&SearchType=$SearchType&Node=$Node";      
    }    

    if (isset($Obj->PRODUCTINFO[0]->ERRORMSG[0]->Data))
    {
      $Result = $Obj->PRODUCTINFO[0]->ERRORMSG[0]->Data;
    }
    else
    {
      $PageMenu    = PageMenu($Page, $TotalPages, $PageLink);
      $Result      = checkout();       
      $Result     .= SortSelect($Category, $Sort);
      $Result     .= $PageMenu;  
      $Result     .= GetItemList($Obj, $ItemsPerRow, $ImageSize, $Page);
      $Result     .= $PageMenu;
    }  
    return $Result; 
  }
?>